#!/usr/bin/env python

import sys, os, time
from subprocess import call, Popen

# Try to avoid race conditions with DCHP client.
time.sleep( 5 )

FILE_NAME = '/tmp/net_conf.txt'
CCOTTA_BIN = '/opt/Optenet/CCOTTA_CT1/bin/OptenetCCOTTA'

#os.system( '> /opt/Optenet/CCOTTA_CT1/database/ipranges.dat' )

data = os.popen( 'ifconfig -a' )

start   = True
name    = None
ip      = None
mac     = None
netmask = None

ignores = ('lo',)

out = open( FILE_NAME, 'w' )

for line in data:
    line = line.strip()

    if not line: 
        # end of data:
        if name and mac and ip and netmask and name not in ignores:          
            print>>out, 'Device: %s %s %s %s' % (name, mac, ip, netmask)

        start = True
        name = None
        ip = None
        netmask = None
        continue

    if start:
        # interface name
        name = line.split()[ 0 ]
        mac = line.split()[ -1 ]
        start = False

    elif line.startswith( 'inet addr:' ):
        for i in line.split()[ 1: ]:
            k, v = i.split( ':' )
            if k == 'addr':
                ip = v
            elif k == 'Mask':
                netmask = v

## Get default gateways and save them
lines = os.popen( 'ip route | grep default | cut -f 3 -d" "' )
for ip in lines:
    print>>out, 'Gateway: ' + ip.strip()

out.close()


## Launch CCOTTA and wait
try:
    res = call( CCOTTA_BIN )
    if res < 0:
        print>>sys.stderr, "Child was terminated by signal", -res
    else:
        print>>sys.stderr, 'CCOTTA exited with status: %d' % res
except OSError, e:
    print>>sys.stderr, "Execution failed:", e
except Exception, x:
    print>>sys.stderr, 'Other exception...', x

## Come back to original state

## Wait for the TAP interfaces to be
## unregistered properly.
time.sleep( 3 )

data = open( FILE_NAME )

for line in data:
    if line.startswith( 'Device' ):
        name, mac, ip, netmask = line.split()[ 1: ]
	os.system( '/sbin/iptables -D INPUT -i filt_%s -j DROP' % name)
        os.system( '/sbin/ifconfig filt_%s down' % name )
        os.system( '/sbin/nameif %s %s' % ( name, mac ) )
        os.system( '/sbin/ifconfig %s %s netmask %s' % ( name, ip, netmask ) )
	os.system( '/sbin/ifconfig %s arp' % name )
        os.system( '/sbin/ifconfig %s up' % name )

    elif line.startswith( 'Gateway' ):
        gw = line.split()[ 1 ]
        os.system( '/sbin/route add default gw %s' % gw )

os.system( 'rm ' + FILE_NAME )

