#!/usr/bin/env python

import sys, os, time
from subprocess import call, Popen

FILE_NAME = '/tmp/net_conf.txt'
CCOTTA_BIN = '/opt/Optenet/CCOTTA_CT1/bin/OptenetCCOTTA'

#os.system( '> /opt/Optenet/CCOTTA_CT1/database/ipranges.dat' )

data = os.popen( 'ifconfig -a' )

start   = True
name    = None
ip      = None
mac     = None
netmask = None

ignores = ('lo',)

out = open( FILE_NAME, 'w' )

for line in data:
    line = line.strip()

    if not line: 
        # end of data:
        if name and mac and ip and netmask and name not in ignores:          
            print>>out, 'Device: %s %s %s %s' % (name, mac, ip, netmask)

        start = True
        name = None
        ip = None
        netmask = None
        continue

    if start:
        # interface name
        name = line.split()[ 0 ]
        mac = line.split()[ -1 ]
        start = False

    elif line.startswith( 'inet addr:' ):
        for i in line.split()[ 1: ]:
            k, v = i.split( ':' )
            if k == 'addr':
                ip = v
            elif k == 'Mask':
                netmask = v

## Get default gateways and save them
lines = os.popen( 'ip route | grep default | cut -f 3 -d" "' )
for ip in lines:
    print>>out, 'Gateway: ' + ip.strip()

out.close()

