#!/bin/bash

. tools/environment.sh

# Check argument.
if [ $# -ne 1 ]; then
	echo "Format: untar <filename>" >&2
	exit 1
fi

# Installation directory.
INSTALL_DIR="$OPTENET_DIR/CentralManager"

# Backup file.
BACKUP_FILE="${INSTALL_DIR}/${BACKUP_DIR}/$1.tbz2"

if [ ! -e ${BACKUP_FILE} ]; then
	echo "Backup file doesn't exist: ${BACKUP_FILE}"
	exit 2
fi

tar -xvjf ${BACKUP_FILE} 1> /dev/null

