#!/bin/bash
ERROR="\e[31m"
ERROR_MESSAGE="STOP"
OK="\e[32m"
OK_MESSAGE="OK"
RESET="\e[0m"
PID_FORMAT="\e[1m"
BIN_FORMAT="\e[1m"
RUNTIME_FORMAT="\e[1m"
HEADER_FORMAT_A="\e[47m\e[31m"
HEADER_FORMAT_B="\e[40m\e[31m"
if [ $1 ]
then
        MAQUETA=$1
else
        MAQUETA=/opt/Optenet
fi
LISTABINARIOS=$(find $MAQUETA/*/bin/* -type f -perm +100 -name "Optenet*")
LISTA_EXEC=$(find /proc/ -lname "$MAQUETA/*/bin/*" -path "/proc/[0-9]*" -name "exe" 2>/dev/null)

MAX_LEN=0
for BIN_FILE in $LISTABINARIOS
do
        NAME=$(basename $BIN_FILE)
        if [ ${#NAME} -ge $MAX_LEN ]
        then
                MAX_LEN=${#NAME}
        fi
done

printf "%b%-6s%b " $HEADER_FORMAT_A "Status" $RESET
printf "%b%-5s%b " $HEADER_FORMAT_B "PID" $RESET
printf "%b%-"$MAX_LEN"s%b " $HEADER_FORMAT_A "Execl" $RESET
printf "%b%-4s%b " $HEADER_FORMAT_B "Thr" $RESET
printf "%b%-8s%b " $HEADER_FORMAT_A "Time" $RESET
printf "%b%-23s%b " $HEADER_FORMAT_B "Ports" $RESET
printf "%b%s%b " $HEADER_FORMAT_A "Path" $RESET
printf "\n"

for BIN_FILE in $LISTABINARIOS
do
        FOUND=0
        for EXEC_FILE in $LISTA_EXEC
        do
                if [ "$BIN_FILE" == "$(readlink -f $EXEC_FILE)" ]
                then
                        FOUND=1
                        break;
                fi
        done
        DIRNAME=$(dirname $BIN_FILE)
        if [ $FOUND -eq 1 ]
        then
                PID=$(echo $EXEC_FILE | cut -d'/' -f 3)
                N_THREADS=$(ps -elm | grep $PID | grep -v "grep" | wc -l)
                RUNTIME=$(ps -el | grep $PID | grep -v "grep" | tr -s " " | cut -d" " -f 13)
                PORTS=$(netstat -napA inet | grep "$PID/" | grep LISTEN | tr -s " " | cut -d' ' -f4 | cut -d':' -f2 | tr "\n" "," | sed "s/,$//")
                if [ -z $PORTS ]
                then
                        PORTS="-"
                fi
                printf "%b%-6s%b %b%5d%b " $OK $OK_MESSAGE $RESET $PID_FORMAT $PID $RESET
                printf "%b%-"$MAX_LEN"s%s%-4d %8s %23s %b%s%b\n" $BIN_FORMAT $(basename $BIN_FILE) " " $N_THREADS $RUNTIME $PORTS $RESET $(dirname ${DIRNAME#$MAQUETA}) $RESET
        else
                printf "%b%-6s%b %5s " $ERROR $ERROR_MESSAGE $RESET
                printf "%b%-"$MAX_LEN"s%s%-4d %8s %23s %b%s%b\n" $BIN_FORMAT $(basename $BIN_FILE) " " 0 " " " " $RESET $(dirname ${DIRNAME#$MAQUETA}) $RESET
        fi
done


