#!/usr/bin/env python
"""progname:

usage: progname conf key value

"""

import sys
import re

def change_key(lines, key, value):
    keys = key.strip().split('|')
    ik = 0
    level = 0
    for i in range(len(lines)):
        l2 = lines[i].strip()
        if l2 == '{':
            level += 1
        elif l2 == '}':
            level -= 1
            if level < ik:
                ik = level
        m = re.search('^\s*(\w+)\s*', lines[i])
        if m:
            rleft = m.group(1)
            if ik < len(keys) and rleft == keys[ik]:
                if ik == len(keys)-1:
                    indent = '\t' * ik
                    lines[i] = '%s%s = %s\n' % (indent, rleft, value)
                ik += 1

def usage():
    print __doc__
def main(argv):
    if len(argv) != 3:
        usage()
    conf_path, key, value = argv

    finp = open(conf_path)
    lines = finp.readlines()
    finp.close()
    change_key(lines, key, value)
    fout = open(conf_path, 'w')
    fout.writelines(lines)
    fout.close()

if __name__ == "__main__":
    main(sys.argv[1:])

