var ghl = new CControlHighlighter2(	"frmDisabled", "frmError" );
//--------------------------------------------------------------------------------------------------------------------------
function userNameIsValid(userName) {
	if (userName == '') return false;

	var validChars="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_";
    for (var i=0; i<userName.length; i++) {
        if (validChars.indexOf(userName.charAt(i)) < 0) {
            return false;
        }
    }

	return true;
}


function emailIsValid(email) 
{
	if (email == '') return false;

	// the character set typed in is valid
	var validChars="abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_-@.";
    for (var i=0; i<email.length; i++) {
        if (validChars.indexOf(email.charAt(i)) < 0) 
		{
            return false;
        }
    }

	// the order is correct
	// Aaa.bbb@ccc.dd
	// aaa@bbb.cc
	// a-a_a@bbb.cc
	//aaa.bbb@ccc.ddd.ee
	if ((email.indexOf('@') == 0) || 
		(email.indexOf('.') == 0) || 
		(email.indexOf('-') == 0) || 
		(email.indexOf('_') == 0)) 
	{
		return false;
	}

	if ((email.indexOf('@',email.length-1)>0) || 
		(email.indexOf('.',email.length-1)>0) || 
		(email.indexOf('-',email.length-1)>0) || 
		(email.indexOf('_',email.length-1)>0)) 
	{
		return false;
	}
	// @ and . must appear
	if (!(email.indexOf('@') > 0) || 
		!(email.indexOf('.') > 0)) 
	{
		return false;
	}

	// can't appear more than one @
	if ((email.indexOf('@',email.indexOf('@')+1))>0)
	{
		return false; 
	}

	// after a @ must come a .
	if (!(email.indexOf('.',email.indexOf('@'))>0))
	{
		return false; 
	}

	return true;
}


function fnCheckData()
{
    form = document.forms.ident;

    if (form.h_password.value == '') 
	{
  	    _alert("Merci de d&eacute;finir le nouveau mot de passe.");
		form.h_password.focus();
  	    return false;
    }
	

    if(!userNameIsValid(form.h_password.value))
    {
		_alert("Merci de d&eacute;finir et de saisir un mot de passe qui contient uniquement des caract&egrave;res alphanum&eacute;riques.");
		form.h_password.focus();
		return false;
    }

    if (form.h_password.value != form.h_passwordconfirm.value) {
		_alert("Les mots de passe ne co&iuml;ncident pas");
		form.h_passwordconfirm.focus();
		return false;
    }
	if( form.h_question.value == '' ) {
		_alert("Merci de saisir la question qui vous sera pos&eacute;e en cas d'oubli de votre mot de passe.");
		form.h_question.focus();
		return false;
    }
	if (form.h_response.value == '') {
		_alert("Merci de saisir la r&eacute;ponse &agrave; la question qui vous sera pos&eacute;e en cas d'oubli de votre mot de passe.");
		form.h_response.focus();
		return false;
    }

	if (!emailIsValid(form.h_mailaddress.value)) {
		_alert("Merci de saisir une adresse e-mail valide.");
		form.h_mailaddress.focus();
  		return false;
    }

    //form.submit();
    return true;
}




function fnOnLoad()
{
   switch(nError)
   {
   case -1:
    break;
   case 0:
       _alert("Op&eacute;ration r&eacute;alis&eacute;e correctement.");
    break;
   case 10:
    _alert("Le mot de passe actuel est incorrect.");
    break;
   case 20:
    _alert("Il n'a pas &eacute;t&eacute; possible de recevoir tous les param&egrave;tres. L'op&eacute;ration a &eacute;t&eacute; annul&eacute;e.");
    break;
   default:
    _alert("Il n'a pas &eacute;t&eacute; possible de sauvegarder les donn&eacute;es sur le disque. Essayez de r&eacute;p&eacute;ter l'op&eacute;ration. Error="+nError);
    break;
   }
}
