function getIntegerIP(ipvalue) {
	var ip = ipvalue.split('.');
	return  Array(parseInt(ip[0] << 8 | ip[1]), parseInt(ip[2]<<8 | ip[3]));
}
 function LessThan(ip1, ip2) {
	return (ip1[0] <ip2[0] || (ip1[0] ==ip2[0] && ip1[1] <ip2[1]));
 }
 function GreatThan(ip1, ip2) {
	return (ip1[0] >ip2[0] || (ip1[0] ==ip2[0] && ip1[1] >ip2[1]));
 }

 function Equal(ip1, ip2) {
	return (ip1[0] ==ip2[0] && ip1[1] == ip2[1]);
 }
 
function validateIPRange(list, ipFrom, ipTo) {
	for (var i=0; i<list.options.length; i++) {
		var ipranges = list.options[i].value;
		var iprange = ipranges.split('-');
		var ip1 = getIntegerIP(iprange[0]);
		if (iprange.length > 1) {
			var ip2 = getIntegerIP(iprange[1]);
			if (ipTo[0] == 0 && ipTo[1] == 0)  
			{ 
				if ((LessThan(ipFrom, ip2) && GreatThan(ipFrom, ip1)) ||Equal(ip1, ipFrom) 	||Equal(ip2, ipFrom))
				{
					return false;
				}
			}
			else {
				if ((LessThan(ip1, ipTo) && GreatThan(ip1, ipFrom))
					|| (LessThan(ip2, ipTo) && GreatThan(ip2, ipFrom))
					|| (LessThan(ipTo, ip2) && GreatThan(ipTo, ip1))
					|| (LessThan(ipFrom, ip2) && GreatThan(ipFrom, ip1))
					|| Equal(ip1, ipTo) || Equal(ip2, ipTo) ||Equal(ip1, ipFrom) 	||Equal(ip2, ipFrom))
				{
					return false;
				}
			}
		}		
		else {
			if (ipTo[0] == 0 && ipTo[1] == 0) {
				if (Equal(ipFrom, ip1)) 
					return false;
			}
			else {
				if ((LessThan(ip1, ipTo) && GreatThan(ip1, ipFrom)) || Equal(ipFrom, ip1) || Equal(ipTo, ip1))
					return false;
			}
		}	
	}
			
	return true;
}

function onAdd() {
	var from = trim(window.document.getElementById("txtFrom").value);
	var to = trim(window.document.getElementById("txtTo").value);
	if (!isValidIP(from) || (to.length != 0 && !isValidIP(to)))
	{
		alert(INVALIDIP);
		return;
	}
	var intFrom = getIntegerIP(from);
	var intTo = getIntegerIP(to);
	
	if (to.length != 0 && LessThan(intTo, intFrom)) {
		alert(INVALIDIPRANGE);
		return;
	}
	var selIP = window.document.getElementById("selIp")
	if (!validateIPRange(selIP, intFrom, intTo)) {
		alert(IPALREADYINRANGE);
		return;
	}
	if (to.length > 0) var ips = from+'-'+to;
	else var ips = from;
	addToList(ips, selIP, 0);
	window.document.getElementById("txtFrom").value = ' ' ;
	window.document.getElementById("txtTo").value = ' ' ;
}

function onDelete() {
	var list = window.document.getElementById("selIp");
	
	if (list.selectedIndex == -1)
		return ;
	
	var ips = list.options[list.selectedIndex].value;
	var ip = ips.split('-');
	
	window.document.getElementById("txtFrom").value = ip[0];
	if (ip.length > 1)
		window.document.getElementById("txtTo").value = ip[1];	
	delSelectedFromList(list);
}

function getData() {
	return getListValues(window.document.getElementById("selIp"), "|");
}
