// Parses the email and returns an object like 
// { name: 'Person name', receipt: 'email@address'}
function ParseEmail(address)
{
	var name = address.replace(/^[ \t]*/, "").replace(/[ \t]$/, "");
	var receipt = name.match(/<.*>$/);
	if (receipt)
	{
		receipt = receipt[0];
		name = name.substr(0, name.length - receipt.length).replace(/"/g, "").replace(/^[ \t]*/, "").replace(/[ \t]$/, "");
		receipt = receipt.substr(1, receipt.length - 2);
		if (name.length == 0)
			name = receipt;
	}
	else
	{
		receipt = name;
	}
	return { Name: name, Receipt: receipt };
}

// Parses a list of emails separated by ',' 
function ParseEmails(str)
{
	var res = new Array;
	var begin = 0;
	var state = 0;
	var i = 0;
	for (; i < str.length; ++i)
	{
		if (state == 0)
		{
			if (str[i] == '<')
			{
				state = 1;
			}
			else if (str[i] == '"')
			{
				state = 2;
			}
			else if (str[i] == ',')
			{
				res[res.length] = ParseEmail(str.substring(begin, i));
				begin = i + 1;
			}
		}
		else if (state == 1)
		{
			if (str[i] == '>')
				state = 0;
		}
		else if (state == 2)
		{
			if (str[i] == '"')
				state = 0;
			else if (str[i] == '\\')
				state = 3;
		}
		else if (state == 3)
		{
			state = 2;
		}
	}
	res[res.length] = ParseEmail(str.substring(begin, i));
	return res;
}


