var grupoOtrasExtensiones;
var grupos = new Array(0);
var extensiones = {};

function Inserta(nodo, donde)
{
	var it;
		
	it = donde.firstChild;
	while (it && it.posicion < nodo.posicion) {
		it	= it.nextSibling;
	}
	donde.insertBefore(nodo, it);
} // Inserta

function CreaGrupoOpciones(nombre, donde)
{
	var res;
		
	res = {};
	res.visible = false;
	res.padre = donde;
	res.nodo = document.createElement("OPTGROUP");
	res.nodo.setAttribute("label", nombre);
	res.nodo.posicion = grupos.length;
	return res;
} // CreaGrupoOpciones
	
function Grupo(pForm, nombre, special)
{
	this.etiqueta = nombre;
	this.filtrado = CreaGrupoOpciones(nombre,pForm.filtrado);
	if (!special) {
		this.noFiltrado = CreaGrupoOpciones(nombre,pForm.noFiltrado);
	}
	this.extensiones = new Array(0);
	grupos[grupos.length] = this;
	return this;
} // Grupo

function checkFiltradoVacio() 
{
	for (var i = 0; i < grupos.length; ++i) {
		if (grupos[i].filtrado.nodo.childNodes.length) {
//				filtra("_", true);
			return;
		}
	}
//		filtra("_", false);
} // checkFiltradoVacio

function checkGrupoVisible(grupo) 
{
	if (!grupo.nodo.childNodes.length && grupo.visible) {
		grupo.padre.removeChild(grupo.nodo);
		grupo.visible = false;
		checkFiltradoVacio();
	}
	else if (grupo.nodo.childNodes.length && !grupo.visible) {
		Inserta(grupo.nodo, grupo.padre);
		grupo.visible = true;
		checkFiltradoVacio();
	}		
} // checkGrupoVisible

function setFiltrado(ext, valor) 
{
	if (valor) {
		if (ext.grupo.noFiltrado && ext.nodo.parentNode == ext.grupo.noFiltrado.nodo) {
			ext.grupo.noFiltrado.nodo.removeChild(ext.nodo);
			checkGrupoVisible(ext.grupo.noFiltrado);
		}
		if (ext.grupo.filtrado) {
			Inserta(ext.nodo, ext.grupo.filtrado.nodo);
			checkGrupoVisible(ext.grupo.filtrado);
		}
	}
	else {
		if (ext.grupo.filtrado && ext.nodo.parentNode == ext.grupo.filtrado.nodo) {
			ext.grupo.filtrado.nodo.removeChild(ext.nodo);
			checkGrupoVisible(ext.grupo.filtrado);
		}
		if (ext.grupo.noFiltrado) {
			Inserta(ext.nodo, ext.grupo.noFiltrado.nodo);
			checkGrupoVisible(ext.grupo.noFiltrado);
		}
	}
	ext.filtrado = valor;
} // setFiltrado

function RegistraExtension(grupo, extension, descripcion)
{
	var ext;
		
	ext = { };
	ext.filtrado = false;
	ext.nombre = extension;
	ext.grupo = grupo;
	ext.nodo = document.createElement("OPTION");
	ext.nodo.setAttribute("value", extension);
  	ext.nodo.setAttribute("id", 'ext-' + extension);
	ext.nodo.appendChild(document.createTextNode(descripcion));		
	ext.nodo.posicion = grupo.extensiones.length;
	setFiltrado(ext, false);

	extensiones[extension] = ext;
	grupo.extensiones[grupo.extensiones.length] = ext;
	return ext;
} // RegistraExtension

function verificaExtension(str) 
{
	if (str)
	{
		for (var i = 0; i < str.length; ++i) {
			var car = str.charAt(i).toLowerCase();
			if (!(car >= 'a' && car <= 'z') && !(car >= '0' && car <= '9')) {
				alert(M_SOLOALFA);
				return "";
			}
		}
	}
	return str;
} // verificaExtension


function filtra(extension, valor) 
{
	var lFromPrompt;
	var lExts;
	var lStr01;
	var lStr02;
	
	lFromPrompt= false;
	
	if (!extension) {
		extension = verificaExtension(prompt(M_EXTDESEADA, ""));
		if (!extension) {
			return;
		}
		lFromPrompt= true;
	}
	
	var ext = extensiones[extension];
	if (!ext) { /* Creo una extensin de usuario */
		if (lFromPrompt) {
			lStr02= new String(extension);
			
			lExts= window.document.forms.frmFiles.filtrado.options;
			for (lIdx= 0; lIdx < lExts.length; lIdx++) {
				lStr01= new String(lExts[lIdx].value);
				if (lStr01.toString() == lStr02.toLowerCase()) {
					alert(M_YAFILTRADA);
					return;
				}
			}

			lExts= window.document.forms.frmFiles.noFiltrado.options;
			for (lIdx= 0; lIdx < lExts.length; lIdx++) {
				lStr01= new String(lExts[lIdx].value);
				if (lStr01.toString() == lStr02.toLowerCase()) {
					alert(M_EXTAFILTRAR);
					return;
				}
			}
		}
		ext = RegistraExtension(grupoOtrasExtensiones, extension, extension);
	}
	if (ext.filtrado != valor) {
		setFiltrado(ext, valor);
	} 
	else {
	   if (valor)
		   alert(M_YAFILTRADA);
		else
		   alert(M_DELEXISTEXT);
	}
} // filtra

function doFiltraSeleccion(where, valor) 
{
	var set = where.getElementsByTagName("option");
	var tmp = Array(0);
	for (var i = 0; i < set.length; ++i) {
		if (set[i].selected) {
			tmp[tmp.length] = set[i].getAttribute("value");
		}
	}
	for (var i = 0; i < tmp.length; ++i) {
		filtra(tmp[i], valor);
	}
	return tmp.length;
} // doFiltraSeleccion

function filtraSeleccion(pItem)
{
	var lForm;

	lForm= pItem.form;
	if (doFiltraSeleccion(lForm.noFiltrado, true) == 0) {
		alert(M_EXTAFILTRAR);
	}
} // filtraSeleccion
			
function nofiltresSeleccion(pItem) 
{
	var lForm;
		
	lForm= pItem.form;
	if (doFiltraSeleccion(lForm.filtrado, false) == 0) {
		alert(M_EXTANOFILTRAR);
	}
} // nofiltresSeleccion

function carga(pForm, pExts) 
{
	/* Definicin de las categorias */
	grupo = new Grupo(pForm,M_COMPRIMIDOS);
	RegistraExtension(grupo, "arj", "ARJ");
	RegistraExtension(grupo, "rar", "RAR");
	RegistraExtension(grupo, "zip", "ZIP");

	grupo = new Grupo(pForm,M_IMAGENES);
	RegistraExtension(grupo, "bmp", "BMP (Microsoft Windows)");
	RegistraExtension(grupo, "gif", "GIF");
	RegistraExtension(grupo, "jpg", "JPG (JPEG)");
	RegistraExtension(grupo, "jpeg", "JPEG");
	RegistraExtension(grupo, "png", "PNG");

	grupo = new Grupo(pForm,M_MUSICA);
	RegistraExtension(grupo, "mp3", "MP3");
	RegistraExtension(grupo, "ogg", "OGG (Ogg Vorbis)");

	grupo = new Grupo(pForm,M_PROGRAMAS);
	RegistraExtension(grupo, "bat", "BAT (Script MS-DOS)");
	RegistraExtension(grupo, "class", "CLASS (Java)");
	RegistraExtension(grupo, "exe", "EXE (Microsoft Windows)");
	RegistraExtension(grupo, "js", "JS (Javascript)");
	RegistraExtension(grupo, "pif", "PIF (Microsoft Windows)");
	RegistraExtension(grupo, "vbs", "VBS (Visual Basic Script)");
		
	grupo = new Grupo(pForm,M_VIDEOEXT);
	RegistraExtension(grupo, "asf", "ASF (Microsoft Windows)");
	RegistraExtension(grupo, "avi", "AVI (Microsoft Windows)");
	RegistraExtension(grupo, "mov", "MOV (Apple Quicktime)");
	RegistraExtension(grupo, "mpg", "MPG (MPEG)");
	RegistraExtension(grupo, "mpeg", "MPEG");

	grupoOtrasExtensiones = new Grupo(pForm,M_OTRASEXT, true);
	//RegistraExtension(grupo, "_", "(ninguna)");

	/* Cargo las extensiones filtradas */
	var extensionesFiltradas = pExts;
	var tmp = extensionesFiltradas.split('|');
	for (var i = 0; i < tmp.length; ++i) {
		if (tmp[i] != "")
			filtra(tmp[i], true);
	}
} // carga
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
function prFilesOnClick()
{
	var lArrFicheros = getListValues(document.frmFiles.filtrado,'|'), extra = "";
	//alert(lArrFicheros);
	
	Accion=	"/components/WebFilter/FilteringRules/Files/srvFiles.htmopt?" + lRedirectUrlData +
			"&h_rulename="  + lRulename  +
			"&h_rulesfile=" + lRulesFile + 
			"&h_operation=OPT[M_SELEXT]" +
			"&h_ficherossi=" + lArrFicheros + 
			"&h_service=" + pService;
			
	var scantext = document.getElementById("h_scantext");	
	if( scantext ) extra = scantext.checked ? "&h_scantext=True" : "&h_scantext=False";
 	
 	window.open(Accion + extra, window.name);
 	return true;
}
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
function fnBotonVolver()
{
 	Accion=	"/components/WebFilter/FilteringRules/ModifyRule/dspModifyRule.htmopt?"+ lRedirectUrlData +
			"&h_rulename="+lRulename+
			"&h_rulesfile="+lRulesFile + "&h_actualTitle="+prevTitle;
 	window.open(Accion, window.name);
	//history.back();
 	return true;
}
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
function prOnLoad()
{	
	var scantext = document.getElementById("h_scantext");
	
	if( scantext )		
		if( !scantext.checked ) document.getElementById("trEdit").style.visibility = "hidden";			
}
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
function fnClickScanText()
{
	var scantext = document.getElementById("h_scantext");	
	document.getElementById("trEdit").style.visibility = scantext.checked ? "visible" : "hidden";	
}
//------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------