// Cuando se necesita que las funciones trabajen sobre otro documento que no es el de la ventana activa, entonces 
// se cambia esta variable  
gActiveDocument = document;
//===========================================================================================================================
// validate that the time entered string is valid (00:00-23:59)
function fnIsTime(timeString) {
	var time = timeString.split(":");
	var allDigits = /^[0-9]+$/;	
	
	if( time.length!=2 || !allDigits.test(time[0]) || !allDigits.test(time[1]) ) return false;
		
	var hrs  = parseInt(time[0],10);
	var mins = parseInt(time[1],10);
	
	if ( hrs<0  || hrs>23  ) return false;
	if ( mins<0 || mins>59 ) return false;
    return true;
}
//===========================================================================================================================
// Verifica que sea una direccin de correo correcta
function fnIsEmailAddress(pEmail)
{
	var lFilter = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
	return lFilter.test (pEmail);
}

//===========================================================================================================================
// Verifica que sea una entrada correcta
function fnIsValidInput(pValue)
{
	pValue = trim(pValue);
	if (pValue == "")
		return false;
	var lFilter = /^([\w\_\-])+$/;
	return !lFilter.test (pValue);
}

//===========================================================================================================================
// Verifica que sea una direccin mac correcta
function fnIsMacAddress(pEmail)
{
	return !pEmail.match(/^([A-F0-9]{2}:){5}[A-F0-9]{2}$/) ;
}
//===========================================================================================================================
// Verifica que sea una direccin de correo correcta
function fnIsEmailDomain(pEmail)
{
	var lFilter = /^(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
	return lFilter.test (pEmail);
}
//===========================================================================================================================
// verifica que 'strIp' sea un string que represente una direccin IP vlida
// Added by Samuel Jenkins at <20050601>.
function isValidIP(val) {
	var isEmail = /^[\d]{1,3}\.[\d]{1,3}\.[\d]{1,3}\.[\d]{1,3}$/;
	if (!isEmail.test(val))
		return false;
	var ip_array = val.split(".");
	for (i=0; i<ip_array.length; i++) {
		ip_byte = parseInt(ip_array[i]);
		if ((ip_byte < 0) || (ip_byte > 255)) return false;
	}
	return true;
}
//=======================================================================================================================================
//Valida si DateEnd es una fecha posterior a DateBegin
function isValidDateRange (DateBegin, DateEnd, MonthsArr)
{
	var Beg = DateBegin.split ("/");
	var End = DateEnd.split ("/");
	var Contador;
	
	//El ao es mayor?
	if (parseInt (End [2]) > parseInt (Beg [2]))
		return true;
	
	//El ao es menor?
	if (parseInt (End [2]) < parseInt (Beg [2]))
		return false;

	//En este punto, el ao es igual en ambos casos, por lo que mejor preguntamos por el mes
	if (MonthsArr [End [1]] > MonthsArr [Beg [1]])
		return true;
	
	if (MonthsArr [End [1]] < MonthsArr [Beg [1]])
		return false;
	
	//Si llegamos hasta aqu es porque el mes y el ao son iguales, por lo que slo resta comprobar el da
	if (parseInt (End [0]) >= parseInt (Beg [0]))
		return true;
	
	
	return false;
}
//=======================================================================================================================================
/* Reconstruye una IP eliminando los ceros a la izquierda.
Se asume que la IP entrante es vlida
*/
function RebuildIP (Ip)
{
	Ip = Ip.split (".");
	return "" + parseInt (Ip [0]) + "."
			+ parseInt (Ip [1]) + "." 
			+ parseInt (Ip [2]) + "." 
			+ parseInt (Ip [3]);
}
//===========================================================================================================================
// deletes all spaces from string
function trim(strString) {
	strString = strString.replace(/[ ]+/g,'');
	return strString;
}
//===========================================================================================================================
//  check for valid numeric strings, numbers can be positive or negative	
function isNumber(strString) {
	var lIsNumber = /^[\d]+$/;
	return lIsNumber.test( strString );
}
//===========================================================================================================================
//  check for valid numeric strings
function isAllDigits(strString) {
	var allDigits = /^[0-9]+$/;	
	return allDigits.test( strString );
}
//==========================================================================================================================
// Esconde  muestra un control del documento
// recibe el id del control a esconder y una variable bool que indica si se muestra  se esconde
function showCtrl( id, show ) {
	ctrl = gActiveDocument.getElementById(id);
	if( !ctrl ) { alert("unknown control: "+id); return; }
	ctrl.style.display = show ? "" : "none";
}
//===========================================================================================================================
// Deshabilita todos los controles dentro de un elemento con identificador "root"
// Funciona para los siguientes elementos:
//	- input
//	- textArea
//	- select
function prDisableCtrls(root, state) {
	ctrl = gActiveDocument.getElementById(root);
	
	if( !ctrl ) return false;
	
	var elems = ctrl.getElementsByTagName("input");
	for(i=0; i<elems.length; i++) elems[i].disabled = state;
	
	elems = ctrl.getElementsByTagName("textArea");
	for(i=0; i<elems.length; i++) elems[i].disabled = state;
	
	elems = ctrl.getElementsByTagName("select");
	for(i=0; i<elems.length; i++) elems[i].disabled = state;

	return true;
}
//===========================================================================================================================
// Almacena los elementos de list en un string, separando cada elemento con el caracter '|'
function getListValues(list, separator)
{
	// default option
	if( !separator ) separator = "|";
	
	var result = "";
	var set = list.getElementsByTagName("option");
	for ( var i=0; i<set.length; i++ ) {
		if( i>0 ) result += separator;
		result += set[i].value;
	}
	return result;
}
//===========================================================================================================================
// Almacena los elementos seleccionados de list en un string, separando cada elemento con el caracter '|'
function getSelectedListValues(list, separator)
{
	// default option
	if( !separator ) separator = "|";
	
	var result = "";
	var set = list.getElementsByTagName("option");
	for ( var i=0; i<set.length; i++ ) {
		if( set[i].selected ) {
			if( result.length>0 ) result += separator;
			result += set[i].value;
		}
	}
	return result;
}
//===========================================================================================================================
/* THIS CODE SIMPLY ADDS A NEW OPTION TO THE LIST WITHOUT CHECKING FOR DUPLICATED VALUES
	function addToList(text, list, max )
	{
		if (list.length >= max && max>0 ) return;		
		var it = list.lastChild;
		var newOpt = gActiveDocument.createElement("OPTION");
		newOpt.value = text;
		newOpt.appendChild( gActiveDocument.createTextNode(text) );
		list.insertBefore(newOpt, it);
	}
*/
//===========================================================================================================================
// Agrega el texto 'text' al control lista 'list', si max>0 entonces valida que la lista no contenga mas de 'max' elementos
function addToList(text, list, max )
{
	if (list.length >= max && max>0 ) return;
	
	var it = list.firstChild; 
	// search for duplicated values
	while (it) {
		if( it.value==text ) return; // value is already in the list
		it = it.nextSibling;
	}
	var newOpt = gActiveDocument.createElement("OPTION");
	newOpt.value = text;
	newOpt.selected = true;
	newOpt.appendChild( gActiveDocument.createTextNode(text) );
	list.insertBefore(newOpt, it);
}
//===========================================================================================================================
// Agrega el texto 'text' al control lista 'list', si max>0 entonces valida que la lista no contenga mas de 'max' elementos
function addValToList(text, value, list, max )
{
	if (list.length >= max && max>0 ) return;
	
	var it = list.firstChild; 
	// search for duplicated values
	while (it) {
		if( it.value==value ) return; // value is already in the list
		it = it.nextSibling;
	}
	var newOpt = gActiveDocument.createElement("OPTION");
	newOpt.value = value;
	newOpt.selected = true;
	newOpt.appendChild( gActiveDocument.createTextNode(text) );
	list.insertBefore(newOpt, it);
}
//===========================================================================================================================
// funcion para encontrar un valor en el arreglo
Array.prototype.inArray = function (value)
// Returns true if the passed value is found in the
// array.  Returns false if it is not.
{
    var i;
    for (i=0; i < this.length; i++) {
        // Matches identical (===), not just similar (==).
        if (this[i] === value) {
            return true;
        }
    }
    return false;
};
//===========================================================================================================================
// Agrega el grupo de datos 'group' con los elementos 'data' al control lista 'list', si max>0 entonces valida que la lista no contenga mas de 'max' elementos
//Ejemplo group='category',data=Array('Pornografy','economy'); 
function addGroupToList(group,data, list, max )
{
	if (list.length >= max && max>0 ) return;
	
	var it = list.firstChild; 
	// search for duplicated values
	while (it) {
		if(data.inArray(it.value) ) return; // value is already in the list
		it = it.nextSibling;
	}
	var oOptgroup = gActiveDocument.createElement('OPTGROUP');
    oOptgroup.label = group;
    for(i = 0; i < data.length; i++)
    {
      var newOpt = gActiveDocument.createElement('OPTION');
      oOptgroup.appendChild(newOpt);
	  newOpt.appendChild( gActiveDocument.createTextNode(data[i]) );      
      newOpt.value = data[i];
    }
    //oSelect.appendChild(oOptgroup);
	list.insertBefore(oOptgroup, it);
}

//===========================================================================================================================
// Agrega el grupo de datos 'group' con los elementos 'data' al control lista 'list', si max>0 entonces valida que la lista no contenga mas de 'max' elementos
//Ejemplo group='category',data=Array()  ;
//data[ 0 ] = Array('text1','value1');
//data[ 1 ] = Array('text2','value2');
//data[ 2 ] = Array('text3','value3');
function addValGroupToList(group,data, list, max )
{
	if (list.length >= max && max>0 ) return;
	
	var it = list.firstChild; 
	// search for duplicated values
	while (it) {
		if( data.inArray(it.value) ) return; // value is already in the list
		it = it.nextSibling;
	}
	var oOptgroup = gActiveDocument.createElement('OPTGROUP');
    oOptgroup.label = group;
    for(i = 0; i < data.length; i++)
    {
      var newOpt = gActiveDocument.createElement('OPTION');
      oOptgroup.appendChild(newOpt);
	  newOpt.appendChild( gActiveDocument.createTextNode(data[i][0]) ); 
      newOpt.value = data[i][1];
    }
    //oSelect.appendChild(oOptgroup);
	list.insertBefore(oOptgroup, it);
}

//===========================================================================================================================
// Busca el texto 'text' en el control lista 'list', si lo encuentra  entonces regresa el nodo, sino regresa null
function valueExistsInList(strval, list)
{
	var it = list.firstChild; 
	while(it) {
		var tmp = it;
		it = it.nextSibling;
		if(tmp.value==strval) {
			return tmp;
		}
	}
	return null;
}
//===========================================================================================================================
// Busca el texto 'text' en el control lista 'list', si lo encuentra  entonces regresa el nodo, sino regresa null
// La lista, puede contener una serie de valores complejos, en este caso el valor "separator" se envia
// Si por ejemplo cada valor de la lista es a su vez una sublista de items separados por algun 
// caracter de separacin "separator", en este caso, podemos elegir comparar contra todos los elementos o solamente contra alguno en particular
// Ejemplos:
//		valueExistsInList( "test",list,"|", 1 );
//		valueExistsInList( "test",list,"|");
//		valueExistsInList( "test",list );
function findValueInList(strval, list, separator, itnum)
{
	var it = list.firstChild; 
	while(it) {
		var tmp = it;
		it = it.nextSibling;
		
		// option node
		if( !tmp.value ) continue;
		
		// Each list value contains multiple items to compare
		if( separator ) {
			var comps = tmp.value.split(separator);
			// compare with only one element of the list
			if( itnum ) {
				//alert( "multi-compare("+comps.length+"): "+comps[itnum]+"=="+strval );
				if( itnum<comps.length && comps[itnum]==strval ) return tmp;				
			}
			// Compare width all the values
			else {
				for( i=0; i<comps.length; i++ ) {
					//alert( "multi-compare: "+comps[i]+"=="+strval );
					if(comps[i]==strval) return tmp;
				}
			}
		}
		// list contains single values
		else {
			//alert( "single-compare: "+tmp.value+"=="+strval );
			if(tmp.value==strval) return tmp;
		}
	}
	return null;
}
//===========================================================================================================================
// Busca el texto 'text' en el control lista 'list', si lo encuentra  entonces lo remueve
function delFromList(text, list, rmvall )
{
	var it = list.firstChild; 
	// search for duplicated values
	while(it) {
		var tmp = it;
		it = it.nextSibling;
		if(tmp.value==text) {
			list.removeChild(tmp);
		}
		if( !rmvall ) return;
	}
}

//===========================================================================================================================
// Borra todos los elementos seleccionados de la lista
function delSelectedFromList(list)
{
	var it = list.firstChild;
	
	while(it) {
		var tmp = it;
		it = it.nextSibling;
		if(tmp.selected) {
			list.removeChild(tmp);
		}
	}
}
//===========================================================================================================================
// Borra todos los elementos de la lista
function clearList(list)
{
	var it = list.firstChild;
	
	while(it) {
		var tmp = it;
		it = it.nextSibling;
		list.removeChild(tmp);
	}
}	
//===========================================================================================================================	
// Copia los items seleccionados de lstFrom a lstTo, si delSrc es verdadero, adems borra los items seleccionados de lstFrom 
function lstCopySelectedItems(lstFrom,lstTo,delSrc) {
	var it = lstFrom.firstChild;
	var rptd = false;
	while(it) {
		var tmp = it;
		it = it.nextSibling;
		if(tmp.selected) {
			/*Agregando modificacion para no repetir elementos en lstTo*/
			var to_it = lstTo.firstChild;
			while(to_it) {//recorriendo la lista
				var tmp_to = to_it;
				to_it = to_it.nextSibling;
				if(tmp_to.value == tmp.value){//si el valor recuperado es igual al que se esta moviendo/copiando...
					rptd = true;
					break;
				}
			}
			/*fin modificacion. cramirez@optenet.com*/
			// Copy option
			if( delSrc ) {// move
				if (rptd){
					//alert (tmp_to.value + '. VALOR REPETIDO');
					lstFrom.removeChild(tmp);
				}
				else{
					lstTo.insertBefore(tmp, lstTo.lastChild);	
				}
			} else {// copy
				var newOpt = gActiveDocument.createElement("OPTION");
				newOpt.value = tmp.value;
				newOpt.appendChild( gActiveDocument.createTextNode(tmp.text) );
				lstTo.insertBefore(newOpt, lstTo.lastChild);
			}
		}
	}		
}
//===========================================================================================================================	
function prAlertWindow(pTitle,pBody) {
	var Params= 'menubar=no,toolbar=no,'+
				'width=400,height=300,screenX=200,screenY=200,'+
				'scrollbars=1,statusbar=0,resizable=1';
				
	// NOTA: No sustituir document por gActiveDocument!!!
	popupWindow = window.open("", "tinyWindow", Params);
	if( popupWindow ) {
		popupWindow.document.write("<html><body><h1>"+pTitle+"</h1>");
		popupWindow.document.write(pBody);
		popupWindow.document.write("<br><hr>");
		popupWindow.document.write("<center><input type=button onClick='window.close();' value='Close'></center>");
		popupWindow.document.write("</body></html>");
		popupWindow.document.close();
	} else alert(pBody);
	return popupWindow;
}
//===========================================================================================================================	
// Obtiene o cambia el valor del texto de un objeto html como por ejemplo:
// <label>Este es el Texto</label> 
function fnGetElementText(id,txt) {
	elem = gActiveDocument.getElementById(id);
	if( elem )
	if( elem.firstChild ) return elem.firstChild.nodeValue;
	return "";
}

function prSetElementText(id,txt) {
	elem = gActiveDocument.getElementById(id);
	if( elem ){
		if( !elem.firstChild ) 
			elem.appendChild( gActiveDocument.createTextNode(txt) );
		else
			elem.firstChild.nodeValue = txt;
	}
}
//===============================================================================================================	
// Se llama en el evento OnChange de una lista para asegurarse que no se puedan seleccionar mas de "max" elementos
// Opcionalmente se le puede pasar un string con un mensaje de error, el string puede contener un "%d" que ser sustituido por el nmero mximo de elementos permitidos.
// Ejemplo: 
//		M_MAXSELECTEDITMS = "No puede seleccionar mas de %d elementos";
//		selMaxItems(lista,3,M_MAXSELECTEDITMS);
function selMaxItems(lst,max,errMsg)	
{
	// Count selected items
	selItms = 0;
	firstSelectedIndex = -1;
	for( i=0;i<lst.options.length;i++ ) {
		if( lst.options[i].selected ) {
			selItms++;
			firstSelectedIndex = (firstSelectedIndex<0)?i:firstSelectedIndex;
			if( selItms>max )
				lst.options[i].selected = false;
		}
	}
	if( selItms>max ) {
		if( errMsg )
			alert( errMsg.replace("%d",max) );
		if( firstSelectedIndex>=0 )
			lst.options[firstSelectedIndex].selected = true;
		return false;
	}
	return true;
}
//===========================================================================================================================	
function autoResize(id){
    var newheight;
    var newwidth;

    if(document.getElementById){
        newheight=document.getElementById(id).contentWindow.document.body.scrollHeight;
        newwidth=document.getElementById(id).contentWindow.document.body.scrollWidth;
		alert(newheight + '--' + newwidth)
    }

    document.getElementById(id).height= (newheight) + "px";
    document.getElementById(id).width= (newwidth) + "px";
}
//===========================================================================================================================	
function addToListTextValue(text, value, list, max )
{
	if (list.length >= max && max>0 ) return;
	
	var it = list.firstChild; 
	// search for duplicated values
	while (it) {
		if( it.value==text ) return; // value is already in the list
		it = it.nextSibling;
	}
	var newOpt = gActiveDocument.createElement("OPTION");
	newOpt.value = value;
	newOpt.selected = true;
	newOpt.appendChild( gActiveDocument.createTextNode(text) );
	list.insertBefore(newOpt, it);
}
//===========================================================================================================================	
//Deshabilita botones. 
//Recibe como parmetros el arreglo de elementos html que sern deshabilitados y un arreglo
//en donde se alamacenarn las funciones javascript que se ejecutan normalmente cuando el boton esta habilitado
function disableElements(elems, arrayjs){
	var arrElems = elems.length ? elems : new Array(elems);
	
	if( arrayjs.length == 0 ){
		for( var i=0; i<arrElems.length; i++ ){
			arrayjs[i] = arrElems[i].onclick;	
			arrElems[i].onclick = "";
			arrElems[i].className = arrElems[i].className + "Inactivo";	
		}
	}
}
//===========================================================================================================================	
//Habilita botones. 
//Recibe como parmetros el arreglo de elementos html que sern habilitados y el arreglo
//en donde se alamacenaron las funciones javascript que se deben ejecutar normalmente cuando el boton esta habilitado
function enableElements(elems, arrayjs){
	var arrElems = elems.length ? elems : new Array(elems);

	if( arrElems.length == arrayjs.length	){
		for( var i=0; i<arrElems.length; i++ ){
			arrElems[i].onclick = arrayjs[i];	
			arrElems[i].className = String.replace(arrElems[i].className,"Inactivo","");	
		}
		arrayjs.length = 0;
	}
}
//==========================================================================================================================
// Converts special html markups to displayable text
// Also accepts and converts single and double quotation marks, square and angle brackets
// and miscelaneous symbols.
// Also accepts and converts html entities for all the above.
function _htmlDecode( x )
{
	x = x.replace(/&apos;/g,'\x27');
	x = x.replace(/&Szlig;/g,'\xDF');
	x = x.replace(/&szlig;/g,'\xDF');
	x = x.replace(/&iexcl;/g,"\xA1");
	x = x.replace(/&iquest;/g,"\xBF");
	x = x.replace(/&Agrave;/g,"\xC0");
	x = x.replace(/&agrave;/g,"\xE0");
	x = x.replace(/&Aacute;/g,"\xC1");
	x = x.replace(/&aacute;/g,"\xE1");
	x = x.replace(/&Acirc;/g,"\xC2");
	x = x.replace(/&acirc;/g,"\xE2");
	x = x.replace(/&Atilde;/g,"\xC3");
	x = x.replace(/&atilde;/g,"\xE3");
	x = x.replace(/&Auml;/g,"\xC4");
	x = x.replace(/&auml;/g,"\xE4");
	x = x.replace(/&Aring;/g,"\xC5");
	x = x.replace(/&aring;/g,"\xE5");
	x = x.replace(/&AElig;/g,"\xC6");
	x = x.replace(/&aelig;/g,"\xE6");
	x = x.replace(/&Ccedil;/g,"\xC7");
	x = x.replace(/&ccedil;/g,"\xE7");
	x = x.replace(/&Egrave;/g,"\xC8");
	x = x.replace(/&egrave;/g,"\xE8");
	x = x.replace(/&Eacute;/g,"\xC9");
	x = x.replace(/&eacute;/g,"\xE9");
	x = x.replace(/&Ecirc;/g,"\xCA");
	x = x.replace(/&ecirc;/g,"\xEA");
	x = x.replace(/&Euml;/g,"\xCB");
	x = x.replace(/&euml;/g,"\xEB");
	x = x.replace(/&Igrave;/g,"\xCC");
	x = x.replace(/&igrave;/g,"\xEC");
	x = x.replace(/&Iacute;/g,"\xCD");
	x = x.replace(/&iacute;/g,"\xED");
	x = x.replace(/&Icirc;/g,"\xCE");
	x = x.replace(/&icirc;/g,"\xEE");
	x = x.replace(/&Iuml;/g,"\xCF");
	x = x.replace(/&iuml;/g,"\xEF");
	x = x.replace(/&Ntilde;/g,"\xD1");
	x = x.replace(/&ntilde;/g,"\xF1");
	x = x.replace(/&Ograve;/g,"\xD2");
	x = x.replace(/&ograve;/g,"\xF2");
	x = x.replace(/&Oacute;/g,"\xD3");
	x = x.replace(/&oacute;/g,"\xF3");
	x = x.replace(/&Ocirc;/g,"\xD4");
	x = x.replace(/&ocirc;/g,"\xF4");
	x = x.replace(/&Otilde;/g,"\xD5");
	x = x.replace(/&otilde;/g,"\xF5");
	x = x.replace(/&Ouml;/g,"\xD6");
	x = x.replace(/&ouml;/g,"\xF6");
	x = x.replace(/&Oslash;/g,"\xD8");
	x = x.replace(/&oslash;/g,"\xF8");
	x = x.replace(/&Ugrave;/g,"\xD9");
	x = x.replace(/&ugrave;/g,"\xF9");
	x = x.replace(/&Uacute;/g,"\xDA");
	x = x.replace(/&uacute;/g,"\xFA");
	x = x.replace(/&Ucirc;/g,"\xDB");
	x = x.replace(/&ucirc;/g,"\xFB");
	x = x.replace(/&Uuml;/g,"\xDC");
	x = x.replace(/&uuml;/g,"\xFC");
	
	x = x.replace(/\"/g,"\x22");
	x = x.replace(/\'/g,"\x27");
	x = x.replace(/\</g,"\x3C");
	x = x.replace(/\>/g,"\x3E");
	x = x.replace(/\[/g,"\x5B");
	x = x.replace(/\]/g,"\x5D");

	x = x.replace(/&cent;/g,"\xA2");
	x = x.replace(/&pound;/g,"\xA3");
	x = x.replace(/&euro;/g,"\u20AC");
	x = x.replace(/&copy;/g,"\xA9");
	x = x.replace(/&reg;/g,"\xAE");
	x = x.replace(/&ordf;/g,"\xAA");
	x = x.replace(/&ordm;/g,"\xBA");
	x = x.replace(/&deg;/g,"\xB0");
	x = x.replace(/&plusmn;/g,"\xB1");
	x = x.replace(/&times;/g,"\xD7");

	x = x.replace(/&nbsp;/g," ");
	x = x.replace(/<br>/g,"\n");
	return x
}

function _alert( txt ) {
	alert( _htmlDecode(txt) );
}

function _confirm( txt ) {
	return confirm( _htmlDecode(txt) );
}

/*
 * Funcion $ (dollar) 
 * Quick getElement reference 
 *  
 * Sample Usage:
 * var obj1 = document.getElementById('element1');
 * var obj2 = document.getElementById('element2');
 * function alertElements() {
 * var i;
 * var elements = $('a','b','c',obj1,obj2,'d','e');
 * 
 */
function $() {
  var elements = new Array();
  for (var i = 0; i < arguments.length; i++) {
    var element = arguments[i];
    if (typeof element == 'string')
      element = document.getElementById(element);
    if (arguments.length == 1)
      return element;
    elements.push(element);
  }
  return elements;
}



/* addEvent: simplified event attachment */
function addEvent( obj, type, fn ) {
  try{
    if (obj.addEventListener) {
      obj.addEventListener( type, fn, false );
      EventCache.add(obj, type, fn);
    }
    else if (obj.attachEvent) {
      obj["e"+type+fn] = fn;
      obj[type+fn] = function() { obj["e"+type+fn]( window.event ); }
      obj.attachEvent( "on"+type, obj[type+fn] );
      EventCache.add(obj, type, fn);
    }
    else {
      obj["on"+type] = obj["e"+type+fn];
    }
  }catch(e){} //try
}//function
  
var EventCache = function(){
  var listEvents = [];
  return {
    listEvents : listEvents,
    add : function(node, sEventName, fHandler){
      listEvents.push(arguments);
    },
    flush : function(){
      var i, item;
      for(i = listEvents.length - 1; i >= 0; i = i - 1){
	item = listEvents[i];
	if(item[0].removeEventListener){
	  item[0].removeEventListener(item[1], item[2], item[3]);
	};
	if(item[1].substring(0, 2) != "on"){
	  item[1] = "on" + item[1];
	};
	if(item[0].detachEvent){
	  item[0].detachEvent(item[1], item[2]);
	};
	item[0][item[1]] = null;
      };
    }
  };
}();
//addEvent(window,'unload',EventCache.flush);

